variables:
  MAVEN_OPTS: "-Dmaven.repo.local=.m2/repository -Dorg.slf4j.simpleLogger.log.org.apache.maven.cli.transfer.Slf4jMavenTransferListener=WARN -Dorg.slf4j.simpleLogger.showDateTime=true -Djava.awt.headless=true"
  MAVEN_CLI_OPTS: "--show-version --batch-mode -e"
  GRADLE_OPTS: "-Dorg.gradle.daemon=false"

before_script:
- export GRADLE_USER_HOME=`pwd`/.gradle

cache:
  paths:
  - .m2/repository
  
stages:
- validateDev
- buildDev
- dockerDev
- validate
- build
- docker

validate_production:
  stage: validate
  image: gradle:alpine
  only:
  - tags
  tags:
  - production
  script:
  - 'gradle $GRADLE_OPTS check'
  artifacts:
    paths:
    - build/libs/com.ehvlinc.email-service-0.0.1-SNAPSHOT.jar
  
build_production:
  stage: build
  image: gradle:alpine
  only:
  - tags
  tags:
  - production
  script:
  - sed "s/security.jwtKey =.*/security.jwtKey = $JWT/g" src/main/resources/application.properties -i.dev
  - sed "s/spring.mail.host =.*/spring.mail.host = $SMTPHOST/g" src/main/resources/application.properties -i.dev
  - sed "s/spring.mail.port =.*/spring.mail.port = $SMTPPORT/g" src/main/resources/application.properties -i.dev
  - sed "s/spring.mail.username =.*/spring.mail.username = $SMTPUSR/g" src/main/resources/application.properties -i.dev
  - sed "s/spring.mail.password =.*/spring.mail.password = $SMTPPASS/g" src/main/resources/application.properties -i.dev
  - sed "s/spring.mail.properties.mail.smtp.auth =.*/spring.mail.properties.mail.smtp.auth = $SMTPAUTH/g" src/main/resources/application.properties -i.dev
  - sed "s/spring.mail.properties.mail.smtp.starttls.enable =.*/spring.mail.properties.mail.smtp.starttls.enable = $SMTPSTARTTLS/g" src/main/resources/application.properties -i.dev
  - 'gradle $GRADLE_OPTS --build-cache assemble'
  artifacts:
    paths:
    - build/libs/com.ehvlinc.email-service-0.0.1-SNAPSHOT.jar
  
#Remove docker-integration after testing is done.
docker_compose_production:
  stage: docker
  image: tmaier/docker-compose:latest
  only:
  - tags
  except:
  - /^(?!master).+@/    # Ruby RegEx for anything not starting with 'master'
  tags:
  - production
  variables:
    ENV: 'dev'
  before_script:
  - 'docker info'
  script:
  - 'docker-compose up -d --build'
  
validate_dev:
  stage: validateDev
  image: gradle:jdk11
  except:
  - tags
  tags:
  - dev
  script:
  - 'gradle $GRADLE_OPTS check'
  artifacts:
    paths:
    - build/libs/com.ehvlinc.email-service-0.0.1-SNAPSHOT.jar
  


build_dev:
  stage: buildDev
  image: gradle:jdk11
  except:
  - tags
  tags:
  - dev
  script:
  - sed "s/spring.mail.host =.*/spring.mail.host = $SMTPHOSTDEV/g" src/main/resources/application.properties -i.dev
  - sed "s/spring.mail.port =.*/spring.mail.port = $SMTPPORTDEV/g" src/main/resources/application.properties -i.dev
  - sed "s/spring.mail.username =.*/spring.mail.username = $SMTPUSRDEV/g" src/main/resources/application.properties -i.dev
  - sed "s/spring.mail.password =.*/spring.mail.password = $SMTPPASSDEV/g" src/main/resources/application.properties -i.dev
  - sed "s/spring.mail.properties.mail.smtp.auth =.*/spring.mail.properties.mail.smtp.auth = $SMTPAUTHDEV/g" src/main/resources/application.properties -i.dev
  - sed "s/spring.mail.properties.mail.smtp.starttls.enable =.*/spring.mail.properties.mail.smtp.starttls.enable = $SMTPSTARTTLSDEV/g" src/main/resources/application.properties -i.dev
  - 'gradle $GRADLE_OPTS --build-cache assemble'
  artifacts:
    paths:
    - build/libs/com.ehvlinc.email-service-0.0.1-SNAPSHOT.jar
  
  
#Remove docker-integration after testing is done.
docker_compose_dev:
  stage: dockerDev
  image: tmaier/docker-compose:latest
  except:
  - tags
  tags:
  - dev
  only:
  - master
  variables:
    ENV: 'default'
  before_script:
  - 'docker info'
  script:
  - 'docker-compose up -d --build'
